summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
Diffstat (limited to 'sys-libs/readline')
-rw-r--r--sys-libs/readline/Manifest1
-rw-r--r--sys-libs/readline/files/readline-8.0-darwin-shlib-versioning.patch40
-rw-r--r--sys-libs/readline/files/readline-8.0-headers.patch17
-rw-r--r--sys-libs/readline/readline-8.0.ebuild214
4 files changed, 272 insertions, 0 deletions
diff --git a/sys-libs/readline/Manifest b/sys-libs/readline/Manifest
index 8b437c12ad..4eb982c3c0 100644
--- a/sys-libs/readline/Manifest
+++ b/sys-libs/readline/Manifest
@@ -1,6 +1,7 @@
DIST host-libtool-0.1.0.tar.gz 388867 BLAKE2B e8bfd1212f39d6262721c4a12535799f4e3428b83f3174bac373c15813462950218dd689380ab8caaf84186b60c29a1fafadfa1c2d0e5cb7f76f6d1699bdcabc SHA512 d8764d7814abf06556fb6eb19c12c2de1d1dc9f2f325deae55606ddfcf88963d65713d6fbd1fae0ab1a0668d90f84204e1cdcbd557944660ab01ecfe3a824ca5
DIST readline-6.3.tar.gz 2468560 BLAKE2B 24488ec141734c050ba985a93423692396f105619bae3ce5b109bc68a4f43862bcf3a6fb8d82fec1145d665cdb408765e179379bb35f008d09c441fa2e5739df SHA512 f70efaf46d570b85c7637172b0ee2eb9a4aa73ba38a62bb45075e665929d9701b96fba0aea6c767fd9a2a0d39dfe8e70ab06da08f8524aee76a7c502f370a401
DIST readline-7.0.tar.gz 2910016 BLAKE2B 679b8aa7ce003017b729e6d8d4cb69d0f991578441a3e69005090079e61f6aa48b7ad4d0b1f34b6041528cf33254a1bf3ddb05b60db53a06e443d7922d49d0d4 SHA512 18243189d39bf0d4c8a76cddcce75243c1bae8824c686e9b6ba352667607e5b10c5feb79372a1093c1c388d821841670702e940df12eae94bcebdeed90047870
+DIST readline-8.0.tar.gz 2975937 BLAKE2B 95e08b28cc46582f036379413810ca40c97d4d3bc59a9e03e04e57d531573abfbe955f6f1cb86e39c208bf6c3f4c618cff70a87bec596d0b9120909d6c5a2f69 SHA512 41759d27bc3a258fefd7f4ff3277fa6ab9c21abb7b160e1a75aa8eba547bd90b288514e76264bd94fb0172da8a4faa54aab2c07b68a0356918ecf7f1969e866f
DIST readline63-001 1366 BLAKE2B 82af5be99597719329db3f1d6049e75a5654ccf6597cf557c71ad7ada0ac03be87381a7738931eb78716de65902ae87498f574b84150a69eae9cc308c4bfffdd SHA512 e70f89ca52a4eae7e1cddd70de6a7162252231ee029c89bb3fcb0f6c8c8b46c666be910c8b2eee72e96983ec2f1a23663694dc222f67228d82e8e4684f1504a2
DIST readline63-002 1297 BLAKE2B 5ace4a81381910ee48dee8cdbb2ca95a1bef2d1f8acca6d39a910c078c86de10a0fc29486939b336110ecb0281b3edb16e4b985f41e7ee161904728f289fff04 SHA512 4e23bd67433577e6e361d10a6c32768ea9e13b10e77493e565b870f56069b673fbcb0b860225f79fa9931845fc91d35c9a82c1385c23f8b757ebfd59f27851f4
DIST readline63-003 985 BLAKE2B cf2cda505b100d5f820d8bfc99eed6b50e65c92b6a495073352fc7385c6456478594e5c2dc293ce556b66853dff705050fb97982aa25fce452ae53d2cb272cf4 SHA512 6bfb84a5b980091b995e2b96bdf5680f97fe670e6cac1b8606d2d75a1ef922ff5bd4e73f029f7af98a115006b7ab7828146f2cd6986287543d8a29987c91dc12
diff --git a/sys-libs/readline/files/readline-8.0-darwin-shlib-versioning.patch b/sys-libs/readline/files/readline-8.0-darwin-shlib-versioning.patch
new file mode 100644
index 0000000000..5012300b7c
--- /dev/null
+++ b/sys-libs/readline/files/readline-8.0-darwin-shlib-versioning.patch
@@ -0,0 +1,40 @@
+diff -ur readline-6.3.orig/support/shobj-conf readline-6.3/support/shobj-conf
+--- readline-6.3.orig/support/shobj-conf 2014-11-29 13:14:17.000000000 -0200
++++ readline-6.3/support/shobj-conf 2014-11-29 13:32:43.000000000 -0200
+@@ -180,34 +180,8 @@
+ SHLIB_LIBVERSION='$(SHLIB_MAJOR)$(SHLIB_MINOR).$(SHLIB_LIBSUFF)'
+ SHLIB_LIBSUFF='dylib'
+
+- # unused at this time
+- SHLIB_SONAME='$(libdir)/`echo $@ | sed "s:\\..*::"`.$(SHLIB_MAJOR).$(SHLIB_LIBSUFF)'
+-
+- case "${host_os}" in
+- # Darwin versions 1, 5, 6, 7 correspond to Mac OS X 10.0, 10.1, 10.2,
+- # and 10.3, respectively.
+- darwin[1-7].*)
+- SHOBJ_STATUS=unsupported
+- SHOBJ_LDFLAGS='-dynamic'
+- SHLIB_XLDFLAGS='-arch_only `/usr/bin/arch` -install_name $(libdir)/`echo $@ | sed "s:\\..*::"`.$(SHLIB_MAJOR).$(SHLIB_LIBSUFF) -current_version $(SHLIB_MAJOR)$(SHLIB_MINOR) -compatibility_version $(SHLIB_MAJOR)$(SHLIB_MINOR) -v'
+- ;;
+- # Darwin 8 == Mac OS X 10.4; Mac OS X 10.N == Darwin N+4
+- *)
+- case "${host_os}" in
+- darwin[89]*|darwin1[012]*)
+- SHOBJ_ARCHFLAGS='-arch_only `/usr/bin/arch`'
+- ;;
+- *) # Mac OS X 10.9 (Mavericks) and later
+- SHOBJ_ARCHFLAGS=
+- # for 32 and 64bit universal library
+- #SHOBJ_ARCHFLAGS='-arch i386 -arch x86_64'
+- #SHOBJ_CFLAGS=${SHOBJ_CFLAGS}' -arch i386 -arch x86_64'
+- ;;
+- esac
+- SHOBJ_LDFLAGS="-dynamiclib -dynamic -undefined dynamic_lookup ${SHOBJ_ARCHFLAGS}"
+- SHLIB_XLDFLAGS="-dynamiclib ${SHOBJ_ARCHFLAGS}"' -install_name $(libdir)/`echo $@ | sed "s:\\..*::"`.$(SHLIB_MAJOR).$(SHLIB_LIBSUFF) -current_version $(SHLIB_MAJOR)$(SHLIB_MINOR) -compatibility_version $(SHLIB_MAJOR)$(SHLIB_MINOR) -v'
+- ;;
+- esac
++ SHOBJ_LDFLAGS='-dynamiclib -dynamic -undefined dynamic_lookup'
++ SHLIB_XLDFLAGS='-dynamiclib -install_name $(libdir)/`basename $@ $(SHLIB_MINOR)$(SHLIB_DOT)$(SHLIB_LIBSUFF)`$(SHLIB_DOT)$(SHLIB_LIBSUFF) -current_version $(SHLIB_MAJOR)$(SHLIB_MINOR) -compatibility_version $(SHLIB_MAJOR)'
+
+ SHLIB_LIBS='-lncurses' # see if -lcurses works on MacOS X 10.1
+ ;;
diff --git a/sys-libs/readline/files/readline-8.0-headers.patch b/sys-libs/readline/files/readline-8.0-headers.patch
new file mode 100644
index 0000000000..f19a3b136e
--- /dev/null
+++ b/sys-libs/readline/files/readline-8.0-headers.patch
@@ -0,0 +1,17 @@
+Required by bash-5.0 or else compilation fails:
+
+ bashline.c:69:10: fatal error: readline/rlmbutil.h: No such file or directory
+ #include <readline/rlmbutil.h>
+ ^~~~~~~~~~~~~~~~~~~~~
+
+--- readline-8.0/Makefile.in
++++ readline-8.0/Makefile.in
+@@ -153,7 +153,7 @@
+ CREATED_TAGS = TAGS tags
+
+ INSTALLED_HEADERS = readline.h chardefs.h keymaps.h history.h tilde.h \
+- rlstdc.h rlconf.h rltypedefs.h
++ rlstdc.h rlconf.h rltypedefs.h rlmbutil.h
+
+ OTHER_DOCS = $(srcdir)/CHANGES $(srcdir)/INSTALL $(srcdir)/README
+ OTHER_INSTALLED_DOCS = CHANGES INSTALL README
diff --git a/sys-libs/readline/readline-8.0.ebuild b/sys-libs/readline/readline-8.0.ebuild
new file mode 100644
index 0000000000..581f9040a2
--- /dev/null
+++ b/sys-libs/readline/readline-8.0.ebuild
@@ -0,0 +1,214 @@
+# Copyright 1999-2019 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=6
+
+inherit flag-o-matic multilib-minimal toolchain-funcs libtool ltprune
+
+# Official patches
+# See ftp://ftp.cwru.edu/pub/bash/readline-7.0-patches/
+PLEVEL="${PV##*_p}"
+MY_PV="${PV/_p*}"
+MY_PV="${MY_PV/_/-}"
+MY_P="${PN}-${MY_PV}"
+[[ ${PV} != *_p* ]] && PLEVEL=0
+patches() {
+ [[ ${PLEVEL} -eq 0 ]] && return 1
+ local opt=$1
+ eval set -- {1..${PLEVEL}}
+ set -- $(printf "${PN}${MY_PV/\.}-%03d " "$@")
+ if [[ ${opt} == -s ]] ; then
+ echo "${@/#/${DISTDIR}/}"
+ else
+ local u
+ for u in ftp://ftp.cwru.edu/pub/bash mirror://gnu/${PN} ; do
+ printf "${u}/${PN}-${MY_PV}-patches/%s " "$@"
+ done
+ fi
+}
+
+DESCRIPTION="Another cute console display library"
+HOMEPAGE="http://cnswww.cns.cwru.edu/php/chet/readline/rltop.html"
+
+case ${PV} in
+ *_alpha*|*_beta*|*_rc*)
+ SRC_URI+=" ftp://ftp.cwru.edu/pub/bash/${MY_P}.tar.gz"
+ ;;
+ *)
+ SRC_URI="mirror://gnu/${PN}/${MY_P}.tar.gz $(patches)"
+ ;;
+esac
+
+HOSTLTV="0.1.0"
+HOSTLT="host-libtool-${HOSTLTV}"
+HOSTLT_URI="https://github.com/haubi/host-libtool/releases/download/v${HOSTLTV}/${HOSTLT}.tar.gz"
+SRC_URI+=" ${HOSTLT_URI}"
+HOSTLT_S=${WORKDIR}/${HOSTLT}
+
+LICENSE="GPL-3"
+SLOT="0/8" # subslot matches SONAME major
+KEYWORDS="~ppc-aix ~x64-cygwin ~amd64-linux ~x86-linux ~ppc-macos ~x64-macos ~x86-macos ~m68k-mint ~sparc-solaris ~sparc64-solaris ~x64-solaris ~x86-solaris"
+IUSE="static-libs utils"
+
+RDEPEND=">=sys-libs/ncurses-5.9-r3:0=[static-libs?,${MULTILIB_USEDEP}]"
+DEPEND="${RDEPEND}
+ virtual/pkgconfig"
+
+S=${WORKDIR}/${MY_P}
+
+PATCHES=(
+ "${FILESDIR}"/${PN}-5.0-no_rpath.patch
+ "${FILESDIR}"/${PN}-6.2-rlfe-tgoto.patch #385091
+ "${FILESDIR}"/${PN}-7.0-headers.patch
+ "${FILESDIR}"/${PN}-8.0-headers.patch
+
+ "${FILESDIR}"/${PN}-5.2-rlfe-aix-eff_uid.patch
+ "${FILESDIR}"/${PN}-5.2-rlfe-hpux.patch
+ "${FILESDIR}"/${PN}-5.2-ia64hpux.patch
+ "${FILESDIR}"/${PN}-6.0-mint.patch
+ "${FILESDIR}"/${PN}-6.0-rlfe-solaris.patch
+ "${FILESDIR}"/${PN}-6.1-aix-soname.patch
+ "${FILESDIR}"/${PN}-6.1-aix-expfull.patch
+ "${FILESDIR}"/${PN}-6.3-interix.patch
+ "${FILESDIR}"/${PN}-8.0-darwin-shlib-versioning.patch
+
+ "${FILESDIR}"/${PN}-7.0-libtool.patch # this enables building via libtool
+)
+
+# Needed because we don't want the patches being unpacked
+# (which emits annoying and useless error messages)
+src_unpack() {
+ unpack ${HOSTLT}.tar.gz
+ S="${HOSTLT_S}" elibtoolize
+ unpack ${MY_P}.tar.gz
+}
+
+src_prepare() {
+ [[ ${PLEVEL} -gt 0 ]] && eapply -p0 $(patches -s)
+ default
+
+ # Force ncurses linking. #71420
+ # Use pkg-config to get the right values. #457558
+ local ncurses_libs=$($(tc-getPKG_CONFIG) ncurses --libs)
+ sed -i \
+ -e "/^SHLIB_LIBS=/s:=.*:='${ncurses_libs}':" \
+ support/shobj-conf || die
+ sed -i \
+ -e "/^[[:space:]]*LIBS=.-lncurses/s:-lncurses:${ncurses_libs}:" \
+ examples/rlfe/configure || die
+
+ # fix building under Gentoo/FreeBSD; upstream FreeBSD deprecated
+ # objformat for years, so we don't want to rely on that.
+ sed -i -e '/objformat/s:if .*; then:if true; then:' support/shobj-conf || die
+
+ ln -s ../.. examples/rlfe/readline || die # for local readline headers
+}
+
+src_configure() {
+ mkdir -p "${WORKDIR}/${HOSTLT}-${ABI}" || die
+ cd "${WORKDIR}/${HOSTLT}-${ABI}" || die
+ ECONF_SOURCE="${HOSTLT_S}" econf $(use_enable static-libs static)
+ cd "${BUILD_DIR}"
+
+ export PATH="${WORKDIR}/${HOSTLT}-${ABI}:${PATH}"
+ export ncurses_libs=$($(tc-getPKG_CONFIG) ncurses --libs)
+
+ # fix implicit decls with widechar funcs
+ append-cppflags -D_GNU_SOURCE
+ # https://lists.gnu.org/archive/html/bug-readline/2010-07/msg00013.html
+ append-cppflags -Dxrealloc=_rl_realloc -Dxmalloc=_rl_malloc -Dxfree=_rl_free
+
+ # Make sure configure picks a better ar than `ar`. #484866
+ export ac_cv_prog_AR=$(tc-getAR)
+
+ # Force the test since we used sed above to force it.
+ export bash_cv_termcap_lib=ncurses
+
+ # Control cross-compiling cases when we know the right answer.
+ # In cases where the C library doesn't support wide characters, readline
+ # itself won't work correctly, so forcing the answer below should be OK.
+ if tc-is-cross-compiler ; then
+ use kernel_Winnt || export bash_cv_func_sigsetjmp='present'
+ export bash_cv_func_ctype_nonascii='yes'
+ export bash_cv_wcwidth_broken='no' #503312
+ fi
+
+ # This is for rlfe, but we need to make sure LDFLAGS doesn't change
+ # so we can re-use the config cache file between the two.
+ append-ldflags -L.
+ export LDFLAGS="-L${BUILD_DIR}/shlib ${LDFLAGS}" # search local dirs first
+
+ multilib-minimal_src_configure
+}
+
+multilib_src_configure() {
+ local myeconfargs=(
+ --cache-file="${BUILD_DIR}"/config.cache
+ --with-curses
++ --disable-shared # use libtool instead
+ )
+ ECONF_SOURCE="${S}" econf "${myeconfargs[@]}"
+
+ if use utils && multilib_is_native_abi && ! tc-is-cross-compiler ; then
+ # code is full of AC_TRY_RUN()
+ mkdir -p examples/rlfe || die
+ cd examples/rlfe || die
+ ECONF_SOURCE="${S}"/examples/rlfe \
+ econf --cache-file="${BUILD_DIR}"/config.cache
+ fi
+}
+
+multilib_src_compile() {
+ export PATH="${WORKDIR}/${HOSTLT}-${ABI}:${PATH}"
+ export ncurses_libs=$($(tc-getPKG_CONFIG) ncurses --libs)
+ emake shared
+
+ if use utils && multilib_is_native_abi && ! tc-is-cross-compiler ; then
+ # code is full of AC_TRY_RUN()
+ cd examples/rlfe || die
+ local l
+ for l in readline history ; do
+ ln -s ../../shlib/lib${l}$(get_libname)* lib${l}$(get_libname) || die
+ ln -s ../../lib${l}.a lib${l}.a || die
+ done
+ emake LTLINK='libtool --mode=link --tag=CC'
+ fi
+}
+
+multilib_src_install() {
+ export PATH="${WORKDIR}/${HOSTLT}-${ABI}:${PATH}"
+ export ncurses_libs=$($(tc-getPKG_CONFIG) ncurses --libs)
+ emake DESTDIR="${D}" install-shared
+
+ if multilib_is_native_abi ; then
+ gen_usr_ldscript -a readline history #4411
+
+ if use utils && ! tc-is-cross-compiler; then
+ dobin examples/rlfe/rlfe
+ fi
+ fi
+}
+
+multilib_src_install_all() {
+ HTML_DOCS="doc/history.html doc/readline.html doc/rluserman.html" einstalldocs
+ dodoc USAGE
+ docinto ps
+ dodoc doc/*.ps
+
+ prune_libtool_files --all
+}
+pkg_preinst() {
+ # bug #29865
+ # Reappeared in #595324 with paludis so keeping this for now...
+ preserve_old_lib \
+ /$(get_libdir)/lib{history,readline}$(get_libname 4) \
+ /$(get_libdir)/lib{history,readline}$(get_libname 5) \
+ /$(get_libdir)/lib{history,readline}$(get_libname 6)
+}
+
+pkg_postinst() {
+ preserve_old_lib_notify \
+ /$(get_libdir)/lib{history,readline}$(get_libname 4) \
+ /$(get_libdir)/lib{history,readline}$(get_libname 5) \
+ /$(get_libdir)/lib{history,readline}$(get_libname 6)
+}